<% if (request.getParameter("btnClear") != null) {
	session.invalidate();
	response.sendRedirect(request.getRequestURI());
	return;
}
%><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><%@
page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%><%@
page import="com.mindfusion.diagramming.Diagram"%><%@
page import="com.mindfusion.diagramming.SolidBrush"%><%@
page import="java.awt.Color"%><%@
page import="com.mindfusion.diagramming.ShapeNode"%><%@
page import="com.mindfusion.diagramming.TextFormat"%><%@
page import="com.mindfusion.diagramming.Align"%><%@
page import="com.mindfusion.diagramming.ImageAlign"%><%@
page import="com.mindfusion.diagramming.DiagramLink"%><%@
page import="com.mindfusion.diagramming.DiagramNodeList"%><%@
page import="javax.swing.ImageIcon"%><%@
page import="javax.imageio.ImageIO"%><%@
page import="java.io.File"%><%@
page import="com.mindfusion.diagramming.GraphicsUnit"%><%@
page import="com.mindfusion.diagramming.DiagramNode"%><%@
page import="java.io.IOException"%><%@
page import="com.mindfusion.diagramming.LayeredLayout"%><%@
page import="com.mindfusion.diagramming.Orientation"%><%@
page import="java.awt.Font"%><%@
page import="com.mindfusion.diagramming.ArrowHeads"%><%@
page import="com.mindfusion.diagramming.Shape"%><%@
page import="java.awt.Rectangle"%><%@
page import="java.awt.geom.Rectangle2D"%><%@
page import="com.mindfusion.diagramming.Factory"%>
<%@page import="com.mindfusion.diagramming.SaveToStringFormat"%>
<%@page import="com.mindfusion.diagramming.Behavior"%>
<%@page import="com.mindfusion.diagramming.HtmlBuilder"%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>JDiagram JSP example</title>
</head>
<body>
		This sample shows how to use JDiagram both on the server side with Java Server Pages (JSP) and on the client side
		as java applet.<br>
		When rendered as applet in the browser the diagram is fully interactive and events are handled in javascript without
		round trip to the server.<br> 
		When rendered as image map the diagram image is generated on the server and modification requires round trip to the server.<br>
		
		<jsp:useBean id="diagram" class="com.mindfusion.diagramming.Diagram" scope="session" />
		<jsp:setProperty name="diagram" property="measureUnit" value="<%= GraphicsUnit.Pixel %>" />
		<jsp:setProperty name="diagram" property="font" value='<%= new Font("Arial", Font.PLAIN, 12) %>' />
		<jsp:setProperty name="diagram" property="bounds" value="<%= new Rectangle2D.Float(0, 0, 600, 400) %>" />
		<jsp:setProperty name="diagram" property="backBrush" value="<%= new SolidBrush(Color.white) %>" />
		<jsp:setProperty name="diagram" property="selectAfterCreate" value="false" />
		<jsp:setProperty name="diagram" property="adjustmentHandlesSize" value="<%= 6 %>" />
		<jsp:setProperty name="diagram" property="defaultShape" value='<%= Shape.fromId("Rectangle") %>' />
		<jsp:setProperty name="diagram" property="linkHeadShape" value="<%= ArrowHeads.BowArrow %>" />
		<jsp:setProperty name="diagram" property="linkHeadShapeSize" value="<%= 15 %>" />
		
		<%! int random(int min, int max){ return min + (int)Math.min(max, Math.random() * (max - min + 1));} 
			void onRandom(Diagram diagram) throws IOException{ 
				// choose random fill color for the new box
				diagram.setShapeBrush(new SolidBrush(new Color(
					random(0, 255), random(0, 255), random(0, 255))));
		
				Factory factory = diagram.getFactory();
				ShapeNode node = factory.createShapeNode(
						random(10, 520), random(10, 340), 40, 50);
		
				DiagramNodeList nodes = diagram.getNodes();
				int nodeCount = nodes.size();
		
				node.setText(Integer.toString(nodeCount));
				node.setTextFormat( new TextFormat(Align.Center, Align.Far));
				node.setHyperLink("http://mindfusion.eu");
				//node.HyperLink = "javascript: void alert('clicked')";
		
				// setup icon
				node.setTransparent(true);
				File f = new File(getServletContext().getRealPath("Images"),"ico" + random(0, 5) + ".png");
				System.err.println("ico file " + f.getPath());
				node.setImage(ImageIO.read(f));
				node.setImageAlign(ImageAlign.TopCenter);
		
				if (nodeCount > 1)
				{
					// link the box with a previous one
					DiagramNode node1 = nodes.get(nodeCount - 1);
					DiagramNode node2 = nodes.get((int)(Math.random() * (nodeCount - 3)));
					
					DiagramLink link = nodeCount % 2 == 0 
						? factory.createDiagramLink(node2, node1)
						: factory.createDiagramLink(node1, node2);
					link.setHyperLink("http://mindfusion.eu/cgi/HelpDesk/index.php");
		
					if (nodeCount > 5)
					{
						// link the box with a previous one
						node2 = nodes.get((int)(Math.random() * (nodeCount - 3)));
						link = nodeCount % 2 == 1 
							? factory.createDiagramLink(node2, node1)
							: factory.createDiagramLink(node1, node2);
						link.setHyperLink("http://mindfusion.eu/cgi/HelpDesk/index.php");
					}
				}
				diagram.resizeToFitItems(10);
			}
			
			void onLayout(Diagram diagram) throws IOException{
				LayeredLayout ll = new LayeredLayout();
				ll.setLayerDistance(50);
				ll.setNodeDistance(40);
				ll.setStraightenLongLinks(true);
				ll.setSplitLayers(true);
				ll.setOrientation(Orientation.Horizontal);
				ll.arrange(diagram);
				diagram.resizeToFitItems(10);
			}
		%>
		<%
		boolean applet = false;
		if (request.getParameter("imageMapMode") != null) {
			String diagramData = request.getParameter("DiagramData");
			diagram.loadFromString(diagramData);
		}
		else if (request.getParameter("btnLayout") != null)
			onLayout(diagram);
		else if (request.getParameter("btnRandom") != null)
			onRandom(diagram);
		else applet = true;
		
		String inputType = applet ? "button":"submit";
		%>
		<form id="Form1" method="post">
			<input type=<%=inputType %> id="btnRandom" name="btnRandom" value="Random node">
			<input type=<%=inputType %> id="btnLayout" name="btnLayout" value="Layout">
			<input type=<%=inputType %> id="btnClear" name="btnClear" value="Clear"><br>
			<% 
			if (applet) {
				%>
				<input type=hidden name=DiagramData>
				<script>
					iconSize = 32;
					function initNode(node) {
						var applet = document.getElementById('diag');
						var image = applet.loadImage('Images/ico' + Math.floor(Math.random()*4) + '.png');
						node.setImage(image);
						node.setTransparent(true);
						node.setHyperLink('http://mindfusion.eu');
					}
					function onRandom() {
						var applet = document.getElementById('diag');
						var d = applet.getDiagram();
						var f = d.getFactory();
						
						var shapeNode = f.createShapeNode(
							Math.random()*(d.getBounds().getWidth()-iconSize),
							Math.random()*(d.getBounds().getHeight()-iconSize),
							iconSize, iconSize);
						initNode(shapeNode);
						createLink(shapeNode);
						if (d.getNodes().size() > 5)//Math.random() < 0.5 
							createLink(shapeNode);
						//alert('random');
					}
					function createLink(node) {
						// create a link between node and another random node that is not yet linked
						var applet = document.getElementById('diag');
						var d = applet.getDiagram();
						var f = d.getFactory();
						var i = Math.floor(Math.random()*d.getNodes().size());
						var node2 = d.getNodes().get(i);
						if (node == node2) return;
						if (Math.random() < 0.5)
							f.createDiagramLink(node, node2);
						else f.createDiagramLink(node2, node);
					}
					document.getElementById('btnRandom').onclick = onRandom;
					
					function onLayout() {
						var applet = document.getElementById('diag');
						var sh = applet.getScriptHelper();
						ll = sh.createLayeredLayout();
						ll.setLayerDistance(50);
						ll.setNodeDistance(40);
						ll.setStraightenLongLinks(true);
						ll.setSplitLayers(true);
						ll.setOrientation(sh.getConstant('Orientation', 'Horizontal'));
						var d = applet.getDiagramView().getDiagram();
						ll.arrange(d);
						d.resizeToFitItems(10);
						//applet.width = d.getBounds().getWidth();
						//applet.height = d.getBounds().getHeight();
					}
					document.getElementById('btnLayout').onclick = onLayout;
					
					function updateDiagramData() {
						var applet = document.getElementById('diag');
						document.forms['Form1'].DiagramData.value = applet.saveToString(true);
						return true;
					}
					function onClear() {
						var applet = document.getElementById('diag');
						var d = applet.getDiagramView().getDiagram();
						d.clearAll();
					}
					document.getElementById('btnClear').onclick = onClear;
					
					function docClicked(sender, event) {
						var node = sender.getFactory().createShapeNode(event.getMousePosition().getX(), event.getMousePosition().getY(), iconSize, iconSize);
						initNode(node);
					}
					
					function appletStarted() {
						var applet = document.getElementById('diag');
						var d = applet.getDiagramView().setBehavior(applet.getScriptHelper().getConstant('Behavior', 'DrawLinks'));
					}
				</script>
				Diagram rendered as applet.
				<input type=submit name=imageMapMode value='Render as image map' onclick='updateDiagramData()'><br>
				<applet id="diag" 
					archive="JDiagram.jar" 
					width="800px"
					height="600px"
					code="com.mindfusion.diagramming.DiagramApplet"
					mayscript>
					<param name='DiagramData' value='<%= diagram.saveToString(SaveToStringFormat.CompressedXml, false)%>'>
					<param name='Clicked' value='docClicked'>
					<param name='AppletStarted' value='appletStarted'>
				</applet>
			<%} else {%>
				Diagram rendered as image map.
				<input type=submit name=appletMode value='Render as applet'><br>
				<img id="imgChart" src="ImageGen?id=diagram" usemap='#map'>
				<%= new HtmlBuilder(diagram).createImageMap("map") %>
			<%}%>
		</form>
</body>
</html>