import java.awt.GridLayout;

import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;

import com.mindfusion.diagramming.Diagram;
import com.mindfusion.diagramming.DiagramView;


public class ChildFrame extends JInternalFrame
{
	public ChildFrame(String title)
	{
		super(title, true, true, true, true);
		diagView = new DiagramView();
		scrPane = new JScrollPane(diagView);
		
		setSize(350, 350);
		setLayout(new GridLayout(1,1));
		add(scrPane);
	}
	
	public void setDiagram(Diagram diagram)
	{
		diagView.setDiagram(diagram);
	}
	
	private DiagramView diagView;
	private JScrollPane scrPane;
}
