import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


class AddDiagramDialog extends JDialog{
	private JButton _btnCancel;
	private JButton _btnAdd;
	private JTextField _tField;
	private JLabel _label;
	private boolean _accept = false;
	
	public AddDiagramDialog(JFrame parent){
	
		super(parent, true);
		_btnCancel = new JButton();
		_btnAdd = new JButton();
		_tField = new JTextField();
		_label = new JLabel();
		
		
		// Initialize component
		
		
		//_label
		_label.setName("_label");
		_label.setText("Name:");
		_label.setBounds( 15, 15, 40, 25);
		
		
		//_tField
		_tField.setName("_tField");
		_tField.setBounds( 65, 15, 240, 25);
		_tField.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent e){
				if(e.getKeyCode() == KeyEvent.VK_ENTER)
					onBtnAdd();
			}	
		});
		
		//_btnCancel
		_btnCancel.setName("_btnCancel");
		_btnCancel.setText("Cancel");
		_btnCancel.setBounds( 170, 60, 90, 25 );
		_btnCancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onBtnCancel();
			}
		});
		
		
		//_btnCreate
		_btnAdd.setName("_btnAdd");
		_btnAdd.setText("Add");
		_btnAdd.setBounds(40, 60, 90, 25 );
		_btnAdd.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				onBtnAdd();
			}
		});
		
		Container cp = this.getContentPane();
		cp.setLayout(null);
		
		cp.add(_label);
		cp.add(_tField);
		cp.add(_btnCancel);
		cp.add(_btnAdd);
		
		setTitle("Add diagram");
		setSize(new Dimension(330,140));
		setResizable(false);
		
		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
	}
	
	public String getTextDiagram(){
		return _tField.getText();
	}
	
	public void setTextDiagram(String text){
		_tField.setText(text);	
	}
	
	public boolean getAccepted()
	{
		return _accept;
	}
	
	public void onBtnAdd()
	{
		_accept = true;
		this.setVisible(false);
	}
	
	public void onBtnCancel()
	{
		_accept = false;
		this.setVisible(false);
	}
	
	public void setButtonTitle(String text)
	{
		_btnAdd.setText(text);
	}
	
}